## API Report File for "@genesislcap/foundation-errors"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { LogLevel } from '@genesislcap/foundation-utils';

// @public
export interface ConfirmingAction {
    // (undocumented)
    readonly action: Function;
    // (undocumented)
    readonly label: String;
}

// @public
export interface DismissingAction {
    // (undocumented)
    readonly action?: Function;
    // (undocumented)
    readonly label: String;
}

// @public
export interface ErrorBanner {
    // (undocumented)
    readonly confirmingActions?: Array<ConfirmingAction>;
    // (undocumented)
    readonly dismissingAction?: DismissingAction;
}

// @public
export class ErrorBannerBuilder {
    build(): ErrorBanner;
    withConfirmingAction(confirmingAction: ConfirmingAction): ErrorBannerBuilder;
    withDismissingAction(dismissingAction: DismissingAction): ErrorBannerBuilder;
}

// @public
export enum ErrorBoundaryEvent {
    // (undocumented)
    ERROR_BOUNDARY_EVENT = "error-boundary-event"
}

// @public
export class ErrorBuilder {
    build(): ErrorStructure;
    withAlert(alert: boolean): ErrorBuilder;
    withBanner(banner: ErrorBanner): ErrorBuilder;
    withDialog(dialog: ErrorDialog): ErrorBuilder;
    withErrorDetails(errorDetails: string): ErrorBuilder;
    withLogLevel(logLevel: LogLevel): ErrorBuilder;
    withNotification(notification: ErrorNotification): ErrorBuilder;
    withSnackbar(snackbar: Snackbar): ErrorBuilder;
    withTitle(title: string): ErrorBuilder;
}

// @public
export interface ErrorDialog {
    // (undocumented)
    readonly confirmingActions?: Array<ConfirmingAction>;
    // (undocumented)
    readonly dismissingAction?: DismissingAction;
}

// @public
export class ErrorDialogBuilder {
    build(): ErrorDialog;
    withConfirmingAction(confirmingAction: ConfirmingAction): ErrorDialogBuilder;
    withDismissingAction(dismissingAction: DismissingAction): ErrorDialogBuilder;
}

// Warning: (ae-internal-missing-underscore) The name "ErrorDialogElement" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type ErrorDialogElement = ErrorElement & {
    show: Function;
};

// Warning: (ae-internal-missing-underscore) The name "ErrorElement" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type ErrorElement = HTMLElement & {
    error: ErrorStructure;
};

// @public
export interface ErrorNotification {
    // (undocumented)
    readonly autoClose?: boolean;
    // (undocumented)
    readonly closeTimeout?: number;
    // (undocumented)
    readonly type?: ErrorNotificationType;
}

// @public
export type ErrorNotificationType = 'warning' | 'success';

// @public
export interface ErrorStructure {
    // (undocumented)
    readonly config?: {
        readonly logLevel?: LogLevel;
        readonly alert?: boolean;
        readonly notification?: ErrorNotification;
        readonly banner?: ErrorBanner;
        readonly snackbar?: Snackbar;
        readonly dialog?: ErrorDialog;
    };
    // (undocumented)
    readonly errorDetails: string;
    // (undocumented)
    readonly logLevel?: LogLevel;
    // (undocumented)
    readonly title: string;
}

// @public
export const getErrorBannerBuilder: () => ErrorBannerBuilder;

// @public
export const getErrorBuilder: () => ErrorBuilder;

// @public
export const getErrorContainer: (id: string, tagName: String) => HTMLElement;

// @public
export const getErrorDetails: (details: ErrorStructure) => string;

// @public
export const getErrorDialogBuilder: () => ErrorDialogBuilder;

// @public
export const getLoglevel: (details: ErrorStructure) => LogLevel;

// @public
export const getNotificationBuilder: () => NotificationBuilder;

// @public
export const getSnackbarBuilder: () => SnackbarBuilder;

// @public
export class NotificationBuilder {
    build(): ErrorNotification;
    withAutoClose(autoClose: boolean): NotificationBuilder;
    withCloseTimeout(closeTimeout: number): NotificationBuilder;
    withType(type: ErrorNotificationType): NotificationBuilder;
}

// Warning: (ae-internal-missing-underscore) The name "showDialog" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export const showDialog: (error: ErrorStructure, tagName: String) => void;

// @public
export const showError: (error: ErrorStructure, tagName: String) => void;

// Warning: (ae-internal-missing-underscore) The name "showNotification" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export const showNotification: (error: ErrorStructure, tagName: String) => void;

// Warning: (ae-internal-missing-underscore) The name "showSnackbar" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export const showSnackbar: (error: ErrorStructure, tagName: String) => void;

// @public
export interface Snackbar {
    // (undocumented)
    readonly confirmingActions?: Array<ConfirmingAction>;
    // (undocumented)
    readonly type?: SnackbarType;
}

// @public
export class SnackbarBuilder {
    build(): Snackbar;
    withConfirmingAction(confirmingAction: ConfirmingAction): SnackbarBuilder;
    withType(type: SnackbarType): SnackbarBuilder;
}

// @public
export type SnackbarType = 'error';

// (No @packageDocumentation comment for this package)

```
